-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["DRUID"] = {}
lib.classes["DRUID"][1] = function()
	lib.AddSpell("Wrath",{5176}) -- Wrath
	lib.AddSpell("Starfire",{2912}) -- Starfire
	lib.AddSpell("Moonfire",{8921}) -- Moonfire
	lib.AddSpell("Starsurge",{78674}) -- Starsurge
	
	lib.AddAura("Moonfire",8921,"debuff","target") -- Moonfire
	lib.AddAura("Solar",48517,"buff","player") -- Solar
	lib.AddAura("Lunar",48518,"buff","player") -- Lunar
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	table.insert(cfg.plistdps,"Starsurge")
	table.insert(cfg.plistdps,"Wrath")
	table.insert(cfg.plistdps,"end")
	cfg.plist=cfg.plistdps
	
	cfg.case = {
		["Moonfire_noMoonfire"] = function ()
			local t = lib.GetAura({"Moonfire"})
			if t<2 then
				return lib.SimpleCDCheck("Moonfire")
			end
			return nil
		end,
		["Starsurge"] = function ()
			if not lib.SpellCasting("Starsurge") then
				return lib.SimpleCDCheck("Starsurge")
			end
			return nil
		end,
	}
	
	cfg.onpower=true
	cfg.spellcaster=true
	return true
end
