-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["SHAMAN"] = {}
lib.classes["SHAMAN"][2] = function()
--[[	cfg.Sets={}
	cfg.Sets["T10Enh"] = {50830,50831,50832,50833,50834,51195,51196,51197,51198,51199,51240,51241,51242,51243,51244}
	cfg.SetItems = {}]]
		
	cfg.spells={}
	lib.AddSpell("ss",{17364,73899}) -- SS PS
	lib.AddSpell("melee",{6603}) -- Melee
	lib.AddSpell("es",{8042}) -- ES
	lib.AddSpell("fs",{8050}) -- FS
	lib.AddSpell("ll",{60103}) -- LL
	lib.AddSpell("fn",{1535}) -- FN
	lib.AddSpell("sr",{30823}) -- SR
	lib.AddSpell("sw",{51533}) -- Spirit Wolfs
	lib.AddSpell("ls",{324}) -- LS
	lib.AddSpell("st",{3599}) -- Searing Totem
	cfg.notaoetotem = {}
	cfg.notaoetotem[cfg.spells["st"].name] = true
	lib.AddSpell("mt",{8190}) -- Magma Totem
	lib.AddSpell("fet",{2894}) -- Fire Elemental Totem
	lib.AddSpell("ftt",{8227}) -- Flametongue Totem
	
	cfg.aoetotem = {}
	cfg.aoetotem[cfg.spells["mt"].name] = true
	cfg.aoetotem[cfg.spells["fet"].name] = true
	cfg.aoetotem[cfg.spells["ftt"].name] = true
	lib.AddSpell("ue",{73680}) -- UE
--	lib.AddSpell("mw",{53817},true,true) -- MW
	lib.AddSpell("lb",{403}) -- Lightning Bolt
	lib.AddSpell("cl",{421}) -- Chain Lightning
	lib.AddSpell("wfw",{8232}) -- Windfury Weapon
	lib.AddSpell("ftw",{8024}) -- Flametongue Weapon
	
	cfg.auras={}
	lib.AddAura("ss",17364,"debuff","target") -- SS
	lib.AddAura("fs",8050,"debuff","target") -- FS
	lib.AddAura("uf",73683,"buff","player") -- Unleash Flame
	lib.AddAura("ls",324,"buff","player") -- LS
	lib.AddAura("ws",52127,"buff","player") -- Water Shield
	lib.AddAura("earth",974,"buff","player","any") -- Earth Shield
	lib.AddAura("mw",53817,"buff","player") -- MW
		
	lib.UpdateTotem(1)
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"wfw")
	table.insert(cfg.plistdps,"ftw")
	table.insert(cfg.plistdps,"ls")
	table.insert(cfg.plistdps,"firetotem")
	table.insert(cfg.plistdps,"ll")
	table.insert(cfg.plistdps,"ss_new")
	table.insert(cfg.plistdps,"fs_uf")
	table.insert(cfg.plistdps,"lb_mw")
	table.insert(cfg.plistdps,"ue")
	table.insert(cfg.plistdps,"ss")
	table.insert(cfg.plistdps,"es")
--	table.insert(cfg.plistdps,"sw")
	table.insert(cfg.plistdps,"end")
		
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"wfw")
	table.insert(cfg.plistaoe,"ftw")
	table.insert(cfg.plistaoe,"ls")
	table.insert(cfg.plistaoe,"firetotem")
	table.insert(cfg.plistaoe,"fs_aoe")
	table.insert(cfg.plistaoe,"fn")
	table.insert(cfg.plistaoe,"cl_mw")
	table.insert(cfg.plistaoe,"ue")
	table.insert(cfg.plistaoe,"ss")
	table.insert(cfg.plistaoe,"ll")
	table.insert(cfg.plistaoe,"es")
--	table.insert(cfg.plistaoe,"sw")
	table.insert(cfg.plistaoe,"end")
		
	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["wfw"] = function()
			if cfg.Weapons.Main~=1 then
				return lib.SimpleCDCheck("wfw")
			end
			return nil
		end,
		["ftw"] = function()
			if cfg.Weapons.Off~=1 then
				return lib.SimpleCDCheck("ftw")
			end
			return nil
		end,
		["firetotem"] = function()
			local t = lib.GetTotem(1)
			if cfg.onGround and t<3 then
				return lib.SimpleCDCheck("st")
			end
			return nil
		end,
		["ls"] = function ()
			local t = lib.GetAura({"earth","ws","ls"})
			if t<3 then
				return lib.SimpleCDCheck("ls")
			end
			return nil
		end,
		["fs_uf"] = function ()
			local t = lib.GetAura({"uf"})
			if t>0 then
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["fs_aoe"] = function ()
			local t = lib.GetAura({"fs"})
			if t<=cfg.shock_cd then
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["lb_mw"] = function ()
			local t,s = lib.GetAura({"mw"})
			if t>0 and s==5 then
				return lib.SimpleCDCheck("lb")
			end
			return nil
		end,
		["cl_mw"] = function ()
			local t,s = lib.GetAura({"mw"})
			if t>0 and s==5 then
				return lib.SimpleCDCheck("cl")
			end
			return nil
		end,
		["ss_new"] = function ()
			local t = lib.GetAura({"ss"})
			if t==0 then
				return lib.SimpleCDCheck("ss")
			end
			return nil
		end,
	}

	lib.rangecheck=function()
		if lib.inrange("ss") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("lb") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	return true
end

lib.classes["SHAMAN"][1] = function()
			
	cfg.spells={}
	lib.AddSpell("es",{8042}) -- ES
	lib.AddSpell("fs",{8050}) -- FS
	lib.AddSpell("fn",{1535}) -- FN
	lib.AddSpell("ls",{324}) -- Lightning Shield
	lib.AddSpell("st",{3599}) -- Searing Totem
	lib.AddSpell("mt",{8190}) -- Magma Totem
	lib.AddSpell("fet",{2894}) -- Fire Elemental Totem
	lib.AddSpell("ftt",{8227}) -- Flametongue Totem
	lib.AddSpell("em",{16166}) -- Elemental Mastery
	lib.AddSpell("ts",{51490}) -- Thunderstorm
	
	cfg.notaoetotem = {}
	cfg.notaoetotem[cfg.spells["st"].name] = true
	cfg.notaoetotem[cfg.spells["fet"].name] = true
	cfg.notaoetotem[cfg.spells["ftt"].name] = true
	cfg.aoetotem = {}
	cfg.aoetotem[cfg.spells["mt"].name] = true
	
	lib.AddSpell("ue",{73680}) -- UE
	lib.AddSpell("lb",{403}) -- Lightning Bolt
	lib.AddSpell("lab",{51505}) -- Lava Burst
	lib.AddSpell("cl",{421}) -- Chain Lightning
	lib.AddSpell("eq",{61882}) -- Earthquake
	lib.AddSpell("ftw",{8024}) -- Flametongue Weapon
	
	cfg.auras={}
	lib.AddAura("fs",8050,"debuff","target") -- FS
	lib.AddAura("uf",73683,"buff","player") -- Unleash Flame
	lib.AddAura("ls",324,"buff","player") -- Lightning Shield
	lib.AddAura("ws",52127,"buff","player") -- Water Shield
	lib.AddAura("earth",974,"buff","player","any") -- Earth Shield
			
	lib.UpdateTotem(1)
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"ts_mana")
	table.insert(cfg.plistdps,"ftw")
	table.insert(cfg.plistdps,"ls")
	table.insert(cfg.plistdps,"firetotem")
	table.insert(cfg.plistdps,"fs")
	table.insert(cfg.plistdps,"em")
	table.insert(cfg.plistdps,"lab")
	table.insert(cfg.plistdps,"es_ls")
	table.insert(cfg.plistdps,"lb")
	table.insert(cfg.plistdps,"ts")
	table.insert(cfg.plistdps,"end")
		
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"ftw")
	table.insert(cfg.plistaoe,"em")
	table.insert(cfg.plistaoe,"eq")
	table.insert(cfg.plistaoe,"firetotem")
	table.insert(cfg.plistaoe,"fs_aoe")
	table.insert(cfg.plistaoe,"fn")
	table.insert(cfg.plistaoe,"cl")
	table.insert(cfg.plistaoe,"ts")
	table.insert(cfg.plistaoe,"end")
		
	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["ts_mana"] = function()
			if cfg.power<2*cfg.spells["es"].powerCost then
				return lib.SimpleCDCheck("ts")
			end
			return nil
		end,
		["ftw"] = function()
			if cfg.Weapons.Main~=1 then
				return lib.SimpleCDCheck("ftw")
			end
			return nil
		end,
		["firetotem"] = function()
			local t = lib.GetTotem(1)
			if cfg.onGround and t<3 then
				return lib.SimpleCDCheck("st")
			end
			return nil
		end,
		["ls"] = function ()
			local t = lib.GetAura({"earth","ws","ls"})
			if t<3 then
				return lib.SimpleCDCheck("ls")
			end
			return nil
		end,
		["lab"] = function ()
			--local t = lib.GetAura({"fs"})
			--if t>2 and not lib.SpellCasting("lab") then
			if not lib.SpellCasting("lab") then
				return lib.SimpleCDCheck("lab")
			end
			return nil
		end,
		["eq"] = function ()
			if not lib.SpellCasting("eq") then
				return lib.SimpleCDCheck("eq")
			end
			return nil
		end,
		["cl"] = function ()
			if not lib.SpellCasting("cl") and lib.SpellTL("eq")>1.5 then
				return lib.SimpleCDCheck("cl")
			end
			return nil
		end,
		["fs"] = function ()
			local t = lib.GetAura({"fs"})
			if t<3 then
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["fs_aoe"] = function ()
			local t = lib.GetAura({"fs"})
			if t==0 then
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["es_ls"] = function ()
			local t,s = lib.GetAura({"ls"})
			if s>=7 and lib.GetAura({"fs"})>lib.SpellTL("es")+cfg.shock_cd then
				return lib.SimpleCDCheck("es")
			end
			return nil
		end,
	}

	lib.rangecheck=function()
		if lib.inrange("es") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("lb") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	cfg.onpower=true
	cfg.spellcaster=true
	return true
end

lib.classevents["SHAMAN"] = function()
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	lib.mypew = function()
		return lib.UpdateTotem(1)
	end
	
	lib.myonupdate = function()
		if lib.UpdateWeaponBuffs() then cfg.Update=true end
		if lib.GroundUpdate() then cfg.Update=true end
	end

	function Heddevents:PLAYER_TOTEM_UPDATE(...)
		if lib.UpdateTotem(1) then
			if cfg.notaoetotem[cfg.totems[1].totemName] and cfg.mode~="dps" then
				cfg.mode = "dps"
				cfg.plist=cfg.plistdps
				print(cfg.mode)
			elseif cfg.aoetotem[cfg.totems[1].totemName] and cfg.mode~="aoe" then
				cfg.mode = "aoe"
				cfg.plist=cfg.plistaoe
				print(cfg.mode)
			end
			cfg.Update=true
		end
	end
	
	cfg.shock_cd = GetTalentInfo(1,6)

	lib.mytal = function()
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(1,6)
		cfg.shock_cd = 6 - 0.5*currRank
	end
end